const assert = require('assert');
const { Given, When, Then } = require('@cucumber/cucumber');

const { fixtures } = require('../../fixtures/server');

const mockValidConfig = fixtures.get('config-valid');
const mockInvalidConfig = fixtures.get('config-invalid');
const mockSchema = require('../../mock/swagger.json');
const { Adapter } = require('../../../dist/adapter');

Given('valid config', function() {
  this.config = mockValidConfig
});

Given('invalid config', function() {
  this.schema = mockSchema;
  this.config = mockInvalidConfig;
});

When('the adapter instance is created', function() {
  let mockAdapter = new Adapter(this.protocol, this.config);
  this.adapter = mockAdapter;
});

Then('a successful response is returned with status {int}', function(expectedStatus) {
  this.call
  .then(response => {
    assert.equal(response.status, expectedStatus);
  });
});

Then('an error response is returned with status {int}', function(expectedStatus) {
  this.call
  .catch((error) => {
    assert.equal(error.response.status, expectedStatus);
  });
});